<!--
  Generated template for the StaskPage page.

  See http://ionicframework.com/docs/components/#navigation for more info on
  Ionic pages and navigation.
-->

<ion-content padding [class]="!activePage ? 'wrap-all hide-page' : 'wrap-all show-page'">
	<div class="close-btn-container">
		<button class="close-btn" (click)="modalDismiss()"></button>
	</div>
	<div class="all-content-container">
		<div class="task-header-container">
			<p class="task-name">{{ task.taskName }}</p>
			<div class="more-option-container" *ngIf="isAdmin || priviledges">
				<button class="more-option" (click)="taskMoreOptions(isAdmin, priviledges)"></button>
			</div>
			<p class="task-section-title">In section: <span class="task-section">{{ taskSection.taskSectionTitle }}</span></p>
		</div>
		<div class="task-content-container">
			<div class="prio-n-assigned-container">
				<div class="priority-container" (click)="selectTaskPriority()">
					<p class="priority-title" *ngIf="taskItems.priority">Priority:</p>
					<div class="priority-color red" *ngIf="taskItems.priority == 'Urgent'"></div>
					<div class="priority-color orange" *ngIf="taskItems.priority == 'High'"></div>
					<div class="priority-color green" *ngIf="taskItems.priority == 'Normal'"></div>
					<div class="priority-color grey" *ngIf="taskItems.priority == 'Low'"></div>
					<p class="priority-level" *ngIf="taskItems.priority">{{ taskItems.priority }}</p>
					<p class="priority-placeholder" *ngIf="!taskItems.priority">Priority...</p>
				</div>
				<div class="assignedmem-container" (click)="assignMemberToTask()">
					<p class="assigned-title" *ngIf="totalAssignedMem > 0">Total Assigned Member:</p>
					<p class="assigned-total" *ngIf="totalAssignedMem > 0">{{ totalAssignedMem }}</p>
					<p class="assigned-placeholder" *ngIf="totalAssignedMem < 1">Member...</p>
				</div>
			</div>
			<div class="due-date-container">
				<div class="due-icon"></div>
				<p class="due-date" *ngIf="dueDate">Due <span class="due-date-value" *ngIf="taskItems.dueDate" (click)="callDueDatePicker()">{{ taskItems.dueDate | date: 'd MMMM yyyy h:mm a' }}</span></p>
				<p class="due-date-placeholder" *ngIf="!dueDate" (click)="callDueDatePicker()">Due Date...</p>
				<button class="clear-dd-btn" *ngIf="dueDate && isAdmin" (click)="clearDueDate()"></button>
			</div>
			<div class="sub-task-container">
				<div class="sub-task-header-container" (click)="expandTaskList()">
					<div class="sub-task-icon"></div>
					<p class="sub-task-title">Sub-Task</p>
					<button [class]="expandSubTask ? 'expand-btn' : 'collapse-btn'"></button>
				</div>
				<div [class]="expandSubTask ? 'sub-task-content-container expanded' : 'sub-task-content-container collapsed'">
					<div class="no-subtask-container" *ngIf="!isAdmin && !priviledges && totalOfSubTask == 0">
						<p class="no-subtask">There is no Sub-Task added yet.</p>
					</div>
					<div class="sub-task-list">
						<div class="sub-task-item" *ngFor="let subTasks of subTaskObjectList">
							<ion-checkbox class="sub-task-checkbox" (ionChange)="subTaskStatusChange(subTasks)" [checked]="subTasks.isDone" [disabled]="!isAdmin && !priviledges"></ion-checkbox>
							<div [class]="isAdmin ? 'sub-task-label-container' : 'sub-task-label-container na'" >
								<p class="sub-task-label">{{ subTasks.subTaskTitle }}</p>
							</div>
							<button class="remove-sub-task-btn" *ngIf="isAdmin" (click)="deleteSelectedSubTask(subTasks)"></button>
						</div>
					</div>
					<div class="sub-task-input-container" *ngIf="isAdmin || priviledges">
						<ion-input placeholder="Add Sub-Task..." [(ngModel)]="subTask.subTaskTitle" [class]="isAdmin && totalOfSubTask == 0 ? 'sub-task-input admin' : 'sub-task-input'" (input)="countInputLength()"></ion-input>
						<button class="add-sub-task-btn" (click)="addSubTask(subTask)" [disabled]="addSubTaskBtnDisabled"></button>
					</div>
				</div>
			</div>
			<div class="poll-container">
				<div class="poll-header-container">
					<div class="poll-icon"></div>
					<p class="poll-title">Poll</p>
					<button class="add-icon" (click)="addPolling()" *ngIf="!addPollingPending && !pollIsCreated && isAdmin"></button>
					<button class="close-icon" (click)="addPolling()" *ngIf="addPollingPending && !pollIsCreated && isAdmin"></button>
					<button class="delete-icon" (click)="removePolling()" *ngIf="isAdmin && pollIsCreated"></button>
				</div>
				<div [class]="expandSubTask ? 'create-poll-container sub-expanded' : 'create-poll-container'" *ngIf="addPollingPending && !pollIsCreated">
					<ion-item class="polling-type-item">
						<ion-label><span class="required-field">*</span>Polling Type</ion-label>
						<ion-select [(ngModel)]="poll.pollingType" (ionChange)="checkPollingType()">
							<ion-option value="multiple">Multiple Choices</ion-option>
							<ion-option value="single">Single Choices</ion-option>
						</ion-select>
					</ion-item>
					<ion-list class="multiple-choice-options-list" *ngIf="pollMultipleOptions">
						<ion-list-header class="multiple-choice-options-header"><span class="required-field">*</span>Multiple Choice Options:</ion-list-header>
						<ion-item class="multiple-choice-options-item">
							<ion-label class="multiple-choice-options-label-1" item-left>Allow </ion-label>
							<ion-input placeholder="No." class="multiple-choice-options-input" type="number" [(ngModel)]="numOfAllowedVote" item-left></ion-input>
							<ion-label class="multiple-choice-options-label-2" item-right>vote for each person.</ion-label>
						</ion-item>
					</ion-list>
					<ion-item class="polling-target-item">
						<ion-label><span class="required-field">*</span>Polling Target</ion-label>
						<ion-select [(ngModel)]="poll.pollingTarget">
							<ion-option value="group">Group Member</ion-option>
							<ion-option value="assigned">Assigned Member</ion-option>
						</ion-select>
					</ion-item>
					<div class="poll-due-date-container-wrap">
						<div class="poll-due-date-container" (click)="callPollDatePicker()">
							<p class="poll-due-date-title">End Date/Time</p>
							<p *ngIf="!pollDueDate" class="poll-due-date-no-selection">End date...</p>
							<p *ngIf="pollDueDate" class="poll-due-date-selected">{{ formatPollDate(pollDueDate) | date: 'd MMMM yyyy h:mm a'}}</p>
						</div>
					</div>
					<ion-item class="poll-option">
						<ion-label class="poll-option-header"><span class="required-field">*</span>Poll Options:</ion-label>
					</ion-item>
					<div *ngFor="let option of pollOptions; let i = index; let last = last; let first = first" class="poll-options-input-container">
						<div class="poll-options-input-item-not-last" *ngIf="!last">
							<ion-input placeholder="Options {{ i + 1 }}" class="poll-options-input" [(ngModel)]="pollOptions[i].option"></ion-input>
							<ion-icon name="trash" class="remove-option-btn-icon" (click)="removePollOptions(i)" *ngIf="pollOptionTotal > 2" color="danger" ></ion-icon>
						</div>
						<div class="poll-options-input-item-last" *ngIf=last>
							<ion-input placeholder="Options {{ i + 1 }}" class="poll-options-input" [(ngModel)]="pollOptions[i].option"></ion-input>
							<ion-icon name="trash" class="remove-option-btn-icon" (click)="removePollOptions(i)" *ngIf="pollOptionTotal > 2" color="danger"></ion-icon>
							<ion-icon name="add" class="add-option-btn-icon" (click)="addPollOptions()"></ion-icon>
						</div>
					</div>
					<ion-item class="poll-create-btn-icon-container">
						<button ion-button round color="secondary" class="poll-create-btn" outline (click)="createPoll(poll)" item-right>
							<ion-icon name="checkmark" class="poll-create-icon"></ion-icon>&nbsp;Create Poll
						</button>
					</ion-item>
				</div>
				<div class="no-poll-created-container" *ngIf="!isAdmin && !pollIsCreated">
					<div class="no-poll-item">
						<span class="no-poll-created-msg">There is no poll created at the moment.</span>
					</div>
				</div>
				<div class="poll-created-single-choice" *ngIf="pollIsCreated && singleChoices">
					<div *ngIf="!voter.hasVoted && eligibleToVote && !pollExpired">
						<div class="single-vote-container" >
							<p class="poll-option-title">Poll Options: Single Choices</p>
							<p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
						</div>
						<ion-item *ngFor="let options of pollOptionsObjectList" class="voting-option-item">
							<ion-label>{{ options.option }}</ion-label>
							<ion-checkbox color="secondary" (click)="updateVote(options)" [checked]="options.key == voter.hasVoted" item-right></ion-checkbox>
						</ion-item>
					</div>
					<div *ngIf="(voter.hasVoted && eligibleToVote) || (!voter.hasVoted && eligibleToVote && pollExpired) || !eligibleToVote">
						<div class="single-vote-container" >
							<p class="poll-option-title">Poll Result: Single Choices</p>
							<p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
						</div>
						<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
							<p class="poll-options-title">{{ options.option }}</p>
							<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
							<ion-icon name="radio-button-off" *ngIf="(!options.key == voter.hasVoted && eligibleToVote) || (!voter.hasVoted && eligibleToVote && pollExpired)" class="poll-not-voted-icon"></ion-icon>
							<ion-icon name="checkmark-circle" color="secondary" *ngIf="options.key == voter.hasVoted && eligibleToVote" class="poll-voted-icon"></ion-icon>
						</div>
					</div>
				</div>
				<div class="poll-created-multiple-choice" *ngIf="pollIsCreated && multipleChoices">
					<div *ngIf="voterMultipleVotes < 1 && eligibleToVote && !pollExpired">
						<div [class]="polls.pollingDueDate ? 'single-vote-container due' : 'single-vote-container no-due'">
							<p class="poll-option-title">Poll Options: Multiple Choices</p>
							<p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
						</div>
						<ion-item *ngFor="let options of pollOptionsObjectList" class="voting-option-item">
							<ion-label>{{ options.option }}</ion-label>
							<ion-checkbox color="secondary" (ionChange)="updateMultipleVote(options)" [disabled]="!checking(options.key)" item-right></ion-checkbox>
						</ion-item>
						<ion-item class="vote-btn-container">
							<button ion-button round class="vote-btn" color="secondary" (click)="submitMultipleVote()" [disabled]="storedVoteTotal < 1" item-right>
								Vote&nbsp;
								<ion-icon name="checkmark" class="vote-btn-icon"></ion-icon>
							</button>
						</ion-item>
					</div>
					<div *ngIf="(voterMultipleVotes.length > 0 && eligibleToVote) || (voterMultipleVotes.length < 1 && eligibleToVote && pollExpired) || !eligibleToVote">
						<div class="single-vote-container" >
							<p class="poll-option-title">Poll Results: Multiple Choices</p>
							<p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
						</div>
						<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
							<p class="poll-options-title">{{ options.option }}</p>
							<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
							<ion-icon name="radio-button-off" *ngIf="(!checkMultipleVote(options.key) && eligibleToVote) || (voterMultipleVotes.length < 1 && eligibleToVote && pollExpired)" class="poll-not-voted-icon"></ion-icon>
							<ion-icon name="checkmark-circle" color="secondary" *ngIf="checkMultipleVote(options.key) && eligibleToVote" class="poll-voted-icon"></ion-icon>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="activity-log-btn-container">
		<button class="log-btn" (click)="openActivityLog()">Activity Log</button>
	</div>
	<ion-item [hidden]="hideComponent">
		<ion-label>Move To Task Section:</ion-label>
		<ion-select #taskSectionList [(ngModel)]="selectedTaskSectionKey" (ionChange)="selectedTaskSect()">
			<div *ngFor="let taskSect of taskSectionList$ | async">
				<ion-option *ngIf="taskSect.key != selectedTaskSectKey" [value]="taskSect">{{ taskSect.taskSectionTitle }}</ion-option>
			</div>
		</ion-select>
	</ion-item>
	<ion-item [hidden]="hideComponent">
		<ion-label>Task Priority</ion-label>
		<ion-select #taskPriorityList [(ngModel)]="selectedTaskPriority" (ionChange)="setTaskPriority()">
			<ion-option value="Urgent">Urgent</ion-option>
			<ion-option value="High">High</ion-option>
			<ion-option value="Normal">Normal</ion-option>
			<ion-option value="Low">Low</ion-option>
			<ion-option value="none">None</ion-option>
		</ion-select>
	</ion-item>
	<ion-datetime picker #dueDatePicker [hidden]="hideComponent" title="Task Due Date" displayFormat="D MMMM YYYY hh:mm A" [(ngModel)]="dueDate" placeholder="Due date..."(ionChange)="setDueDate()" [onlyValid]="{'between': {'initial': minDate, 'final': maxDate}, 'inclusive': true}"></ion-datetime>
	<ion-datetime picker #pollDueDatePicker [hidden]="hideComponent" title="Poll End Date/Time" displayFormat="D MMMM YYYY hh:mm A" pickerFormat="D-MMMM-YYYY HH:mm" [(ngModel)]="pollDueDate" placeholder="End date..." [onlyValid]="{'between': {'initial': minDate, 'final': maxDate}, 'inclusive': true}" class="task-poll-due-date" (ngModelChange)="checkPollDueDate()"></ion-datetime>
</ion-content>
